
Ruby - Bug #7460

メインスレッド終了後のサブスレッド終了待ち処理においてデッドロック検知が動作していない

11/29/2012 10:02 AM - kosaki (Motohiro KOSAKI)

Status: Closed   

Priority: Normal   

Assignee: kosaki (Motohiro KOSAKI)   

Target version:    

ruby -v: ruby-trunk Backport: 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5:

UNKNOWN

Description

[Bug #5368] からの派生なんですが、

Thread.new do

begin

p "sleep1"

sleep

p "sleep2"

ensure

p "stop1"

Thread.stop

p "stop2"

end

end

このスクリプトでデッドロック検知が動かないのはおかしいと思います。

要するに thread_terminate_all() でも vm->sleeperを増やせ、ということなのですが TAG_FATALの考慮漏れが複数箇所に

とっちらかってて、パッチはちょっときたない（添付参照）。くすん

Related issues:

Related to Ruby - Bug #5368: ensure節でsleepするようなThreadがあるとインタプリタが終了しない Closed

History

#1 - 11/29/2012 10:03 AM - kosaki (Motohiro KOSAKI)

- Status changed from Open to Assigned

- Assignee set to kosaki (Motohiro KOSAKI)

#2 - 11/30/2012 10:54 PM - kosaki (Motohiro KOSAKI)

- Category set to core

- Target version set to 2.6

#3 - 12/25/2017 06:15 PM - naruse (Yui NARUSE)

- Target version deleted (2.6)

#4 - 08/07/2019 03:39 PM - jeremyevans0 (Jeremy Evans)

- Status changed from Assigned to Closed

Files

terminate_all-deadlock-check.patch 2.59 KB 11/29/2012 kosaki (Motohiro KOSAKI)
